Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package typechecker
  Definition Classes
    nsc
-  abstract class SuperAccessors extends SubComponent with Transform with TypingTransformers

  This phase performs the following functions, each of which could be split out into its own mini-phase:

  This phase performs the following functions, each of which could be split out into its own mini-phase:

  1. Adds super accessors for all super calls that either appear in a trait or have as a target a member of some outer class.

  2. Converts references to parameter fields that have the same name as a corresponding public parameter field in a superclass to a reference to the superclass field (corresponding = super class field is initialized with subclass field). This info is pre-computed by the `alias` field in Typer. `dotc` follows a different route; it computes everything in SuperAccessors and changes the subclass field to a forwarder instead of manipulating references. This is more modular.

  3. Adds protected accessors if the access to the protected member happens in a class which is not a subclass of the member's owner.

  4. Mangles the names of class-members which are private up to an enclosing non-package class, in order to avoid overriding conflicts. This is a dubious, and it would be better to deprecate class-qualified privates.

  5. This phase also sets SPECIALIZED flag on type parameters with `@specialized` annotation. We put this logic here because the flag must be set before pickling.

  It also checks that:

  1. Symbols accessed from super are not abstract, or are overridden by an abstract override.

  2. If a symbol accessed accessed from super is defined in a real class (not a trait), there are no abstract members which override this member in Java's rules (see scala/bug#4989; such an access would lead to illegal bytecode)

  3. Super calls do not go to some synthetic members of Any (see isDisallowed)

  4. Super calls do not go to synthetic field accessors

  5. A class and its companion object do not both define a class or module with the same name.

  Should've really been called "Accessors" as it handles more than just super accessors.

  Definition Classes
    typechecker
- Phase
- StdPhase
- SuperAccTransformer
- ThicketTransformer
- TypingTransformer

c

scala.tools.nsc.typechecker.SuperAccessors

# SuperAccTransformer

###

#### class SuperAccTransformer extends TypingTransformer

Source
  SuperAccessors.scala

Linear Supertypes
SuperAccessors.TypingTransformer, Global.Transformer, Global.InternalTransformer, Global.Transformer, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. SuperAccTransformer
2. TypingTransformer
3. Transformer
4. InternalTransformer
5. Transformer
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new SuperAccTransformer(unit: Global.CompilationUnit)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from SuperAccTransformer toany2stringadd[SuperAccTransformer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (SuperAccTransformer, B)
   Implicit
     This member is added by an implicit conversion from SuperAccTransformer toArrowAssoc[SuperAccTransformer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def atOwner[A](tree: Global.Tree, owner: Global.Symbol)(trans: => A): A

   Specialized here for performance; the previous blanked introduction of typers in TypingTransformer caused a >5% performance hit for the compiler as a whole.

   Specialized here for performance; the previous blanked introduction of typers in TypingTransformer caused a >5% performance hit for the compiler as a whole.

   Definition Classes
     SuperAccTransformer → TypingTransformer
8.  final def atOwner[A](owner: Global.Symbol)(trans: => A): A
   Definition Classes
     TypingTransformer → Transformer
9.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
10.  var curTree: Global.Tree
    Attributes
      protected
    Definition Classes
      TypingTransformer
11.  def currentClass: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
12.  def currentMethod: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
13.  var currentOwner: Global.Symbol
    Attributes
      protected[scala]
    Definition Classes
      Transformer
14.  def ensuring(cond: (SuperAccTransformer) => Boolean, msg: => Any): SuperAccTransformer
    Implicit
      This member is added by an implicit conversion from SuperAccTransformer toEnsuring[SuperAccTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (SuperAccTransformer) => Boolean): SuperAccTransformer
    Implicit
      This member is added by an implicit conversion from SuperAccTransformer toEnsuring[SuperAccTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: => Any): SuperAccTransformer
    Implicit
      This member is added by an implicit conversion from SuperAccTransformer toEnsuring[SuperAccTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): SuperAccTransformer
    Implicit
      This member is added by an implicit conversion from SuperAccTransformer toEnsuring[SuperAccTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
20.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
21.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from SuperAccTransformer toStringFormat[SuperAccTransformer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
23.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
24.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
25.  var localTyper: (analyzer)#Typer
    Definition Classes
      TypingTransformer
26.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
27.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
28.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
29.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
30.  def toString(): String
    Definition Classes
      AnyRef → Any
31.  def transform(tree: Global.Tree): Global.Tree
    Definition Classes
      SuperAccTransformer → TypingTransformer → InternalTransformer → Transformer
32.  def transformAtOwner(owner: Global.Symbol, tree: Global.Tree): Global.Tree
    Definition Classes
      TypingTransformer
33.  def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]
    Definition Classes
      Transformer
34.  def transformIdents(trees: List[Global.Ident]): List[Global.Ident]
    Definition Classes
      Transformer
35.  def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]
    Definition Classes
      Transformer
36.  def transformModifiers(mods: Global.Modifiers): Global.Modifiers
    Definition Classes
      Transformer
37.  def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]
    Definition Classes
      Transformer
38.  def transformTemplate(tree: Global.Template): Global.Template
    Definition Classes
      Transformer
39.  def transformTrees(trees: List[Global.Tree]): List[Global.Tree]
    Definition Classes
      Transformer
40.  def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]
    Definition Classes
      Transformer
41.  def transformUnit(unit: Global.CompilationUnit): Unit
    Definition Classes
      Transformer
42.  def transformValDef(tree: Global.ValDef): Global.ValDef
    Definition Classes
      Transformer
43.  def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]
    Definition Classes
      Transformer
44.  def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]
    Definition Classes
      Transformer
45.  val treeCopy: Global.TreeCopier
    Definition Classes
      Transformer
46.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
47.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
48.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (SuperAccTransformer, B)
   Implicit
     This member is added by an implicit conversion from SuperAccTransformer toArrowAssoc[SuperAccTransformer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from SuperAccessors.TypingTransformer

### Inherited from Global.Transformer

### Inherited from Global.InternalTransformer

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromSuperAccTransformer to any2stringadd[SuperAccTransformer]

### Inherited by implicit conversion StringFormat fromSuperAccTransformer to StringFormat[SuperAccTransformer]

### Inherited by implicit conversion Ensuring fromSuperAccTransformer to Ensuring[SuperAccTransformer]

### Inherited by implicit conversion ArrowAssoc fromSuperAccTransformer to ArrowAssoc[SuperAccTransformer]

### Ungrouped